/**
 * generated by Xtext 2.19.0
 */
package fr.istic.mML.impl;

import fr.istic.mML.MMLPackage;
import fr.istic.mML.RegressionTree;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Regression Tree</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link fr.istic.mML.impl.RegressionTreeImpl#getRegressionTree <em>Regression Tree</em>}</li>
 * </ul>
 *
 * @generated
 */
public class RegressionTreeImpl extends MLAlgorithmImpl implements RegressionTree
{
  /**
   * The default value of the '{@link #getRegressionTree() <em>Regression Tree</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRegressionTree()
   * @generated
   * @ordered
   */
  protected static final String REGRESSION_TREE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getRegressionTree() <em>Regression Tree</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRegressionTree()
   * @generated
   * @ordered
   */
  protected String regressionTree = REGRESSION_TREE_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected RegressionTreeImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return MMLPackage.Literals.REGRESSION_TREE;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String getRegressionTree()
  {
    return regressionTree;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setRegressionTree(String newRegressionTree)
  {
    String oldRegressionTree = regressionTree;
    regressionTree = newRegressionTree;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, MMLPackage.REGRESSION_TREE__REGRESSION_TREE, oldRegressionTree, regressionTree));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case MMLPackage.REGRESSION_TREE__REGRESSION_TREE:
        return getRegressionTree();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case MMLPackage.REGRESSION_TREE__REGRESSION_TREE:
        setRegressionTree((String)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case MMLPackage.REGRESSION_TREE__REGRESSION_TREE:
        setRegressionTree(REGRESSION_TREE_EDEFAULT);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case MMLPackage.REGRESSION_TREE__REGRESSION_TREE:
        return REGRESSION_TREE_EDEFAULT == null ? regressionTree != null : !REGRESSION_TREE_EDEFAULT.equals(regressionTree);
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuilder result = new StringBuilder(super.toString());
    result.append(" (regressionTree: ");
    result.append(regressionTree);
    result.append(')');
    return result.toString();
  }

} //RegressionTreeImpl
